<template>
    <table :style="tableStyle">
        <thead>
            <tr>
                <th>#</th>
                <th>Vorname</th>
                <th>Nachname</th>
                <th>Geburtsjahr</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
        <PersonTableEntry
                v-for="(currentPerson, index) in props.personArray"
                :person="currentPerson"
                :index="index"
                @delete-selected-person="(helloWorld) => deletePerson(currentPerson, helloWorld)"/>
        </tbody>
    </table>
</template>

<script setup>
    import {computed} from "vue";
    import PersonTableEntry from "@/components/PersonTableEntry.vue";

    const props = defineProps({
        personArray: {
            type: Array,
            required: true
        }
    })

    const emit = defineEmits(['delete'])

    const rgbValue = computed(() => Math.min(props.personArray.length * 100, 255))
    const tableStyle = computed(() => ({
        backgroundColor: `rgb(${rgbValue.value}, ${rgbValue.value}, ${rgbValue.value})`
    }))

    // DAS NICHT MACHEN
    /*const ages = computed(() => props.personArray.map(person => ({
        ...person,
        age: new Date().getFullYear() - person.birthYear
    })))*/

    function deletePerson(person, helloWorld) {
        console.log(person, helloWorld)
        emit('delete', person)
    }
</script>